/**
***************************************************************************
 jwbemexec.java
 This is a test program to send an Indication to CIM Listener.
 Program uses Java URL to do the communication. Also you must
 pass a valid XML file as an input this program.

 The Initial Developer of the Original Code :
     Bapu Patil ( bapu_patil@hp.com)
     Hewlett-Packard Company.

 Modified by:

***************************************************************************
*/

package tests.IndTests;

import java.io.*;
import java.net.*;
import java.security.*;
import sun.misc.*;
//import javax.net.ssl.*;
import com.sun.net.ssl.*;

import java.net.HttpURLConnection.*;
import org.snia.wbemcmd.xml.Base64Encoder;

public class jwbemexec {

//wbemexec [ -h hostname ] [ -p portnumber ]  [ -u username ] [ -w password ] [ -s ] [ inputfilepath ]
//wbemexec [ -h hostname ] [ -p portnumber ]  [ -s ] [ -f inputfilepath ]

  public static void main(String[] args) throws Exception 
  {
        String inputString = "";
        String input;
        String hostname=null;
        int portNumber=0;
        String username;
        String passwd;
        String xmlfile=null;
        String hostURL;
        boolean isSSL=false;
        HttpURLConnection c = null;
        HttpsURLConnection sc = null;
        

        if (args.length < 2) 
        {
            System.out.println("jwbemexec ");
            System.exit(1);
        }
      int i=0;
      while ( i <args.length )
      {
        if ( args[i].equals("-h") )
        {
            i++;
            hostname=args[i];
        }
        else if ( args[i].equals("-p") )
        {
            i++;
            portNumber=Integer.parseInt(args[i]);
        }
        else if ( args[i].equals("-u") )
        {
            i++;
            username=args[i];
        }
        else if ( args[i].equals("-w") )
        {
            i++;
            passwd=args[i];
        }
        else if ( args[i].equals("-f") )
        {
            i++;
            xmlfile=args[i];
        }
        else if ( args[i].equals("-s") )
        {
          isSSL = true;
        } 
        i++;
      }
      if ( isSSL == true )
      {
            //get SSL provider 
            System.setProperty("java.protocol.handler.pkgs",
                                 "com.sun.net.ssl.internal.www.protocol");
            //System.setProperty("java.protocol.handler.pkgs", "javax.net.ssl");
            Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
            hostURL="https://"+hostname+":"+portNumber+"/cimom";
      }
      else
      {
            hostURL="http://"+hostname+":"+portNumber+"/cimom/listen1";
      }
      Base64Encoder b64e=new Base64Encoder("guest:guest");
      String encoded=b64e.processString();

      //byte[] authCookie = "guest:guest".getBytes();
      //BASE64Encoder encoder = new BASE64Encoder();
      //String encoded = encoder.encodeBuffer(authCookie);
      System.out.println(encoded);


    BufferedReader in = new BufferedReader(new FileReader(xmlfile));
    while((input = in.readLine()) != null)
    {
       inputString = inputString + input;
    }

    in.close();

    System.out.println("hostname " + hostURL);
    System.out.println("Sending *********************");
    System.out.println(inputString);
    System.out.println("\n");

    URL wbemURL = new URL(hostURL);
    if ( isSSL == true )
    {
        sc = (HttpsURLConnection)wbemURL.openConnection();
    }
    else
    {
        c = (HttpURLConnection)(wbemURL.openConnection());
    }
    c.setDoOutput(true);
    c.setDoInput(true);

    //if ( encoded != null )
     //    c.setRequestProperty( "Authorization", "Basic " + encoded);

// C++
//CIMProtocolVersion: 1.0
//CIMOperation: MethodCall
//CIMMethod: SendTestIndication
//CIMObject: root/SampleProvider:RT_TestIndication
//
    c.setRequestProperty( "Content-type", "application/xml; charset=\"utf-8\"");

    c.setRequestProperty( "CIMProtocolVersion", "1.0");
    c.setRequestProperty( "CIMOperation", "MethodCall");
    c.setRequestProperty( "CIMMethod", "Indication");
    c.setRequestProperty( "CIMObject", "root/SampleProvider:RT_TestIndication");

    PrintWriter out = new PrintWriter(c.getOutputStream());

    // Here's whether the parameter is set.
    //out.println("xmldoc=" + URLEncoder.encode(inputString));
    out.println(inputString);
    out.flush();
    out.close();

    System.out.println("Read Response ************=");
    BufferedReader in2 = new BufferedReader(new InputStreamReader(c.getInputStream()));

    String inputLine;
    while((inputLine = in2.readLine()) != null)
        System.out.println(inputLine);

    in2.close();

  }
}

